# IRremoteESP8266: IRHaierACYRW02 Class Reference

IRHaierACYRW02 Class Reference

Class for handling detailed Haier ACYRW02 A/C messages. More...

`#include <ir_Haier.h>`

Collaboration diagram for IRHaierACYRW02:
[legend]

## Public Member Functions

| IRHaierACYRW02 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kHaierAcYrw02DefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | setButton (const uint8_t button)
| Set the Button/Command setting of the A/C. More...
uint8_t | getButton (void) const
| Get the Button/Command setting of the A/C. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setPower (const bool on)
| Change the power setting. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
bool | getSleep (void) const
| Get the Sleep setting of the A/C. More...
void | setSleep (const bool on)
| Set the Sleep setting of the A/C. More...
bool | getHealth (void) const
| Get the Health (filter) setting of the A/C. More...
void | setHealth (const bool on)
| Set the Health (filter) setting of the A/C. More...
uint8_t | getTurbo (void) const
| Get the Turbo setting of the A/C. More...
void | setTurbo (const uint8_t speed)
| Set the Turbo setting of the A/C. More...
uint8_t | getSwing (void) const
| Get the Vertical Swing position setting of the A/C. More...
void | setSwing (const uint8_t pos)
| Set the Vertical Swing mode of the A/C. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t new_code[])
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (uint8_t state[], const uint16_t length=kHaierACYRW02StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static uint8_t | convertSwingV (const stdAc::swingv_t position)
| Convert a stdAc::swingv_t enum into it's native setting. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...
static stdAc::swingv_t | toCommonSwingV (const uint8_t pos)
| Convert a stdAc::swingv_t enum into it's native setting. More...

## Private Member Functions

void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | checksum (void)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| Instance of the IR send class. More...
HaierYRW02Protocol | _

## Detailed Description

Class for handling detailed Haier ACYRW02 A/C messages.

## Constructor & Destructor Documentation

## IRHaierACYRW02()

IRHaierACYRW02::IRHaierACYRW02 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## begin()

void IRHaierACYRW02::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## calibrate()

int8_t IRHaierACYRW02::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## checksum()

void IRHaierACYRW02::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## convertFan()

uint8_t IRHaierACYRW02::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## convertMode()

uint8_t IRHaierACYRW02::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## convertSwingV()

uint8_t IRHaierACYRW02::convertSwingV | ( | const stdAc::swingv_t | position | ) |

static

Convert a stdAc::swingv_t enum into it's native setting.

Parameters

  [in] | position | The enum to be converted.

Returns
  The native equivalent of the enum.

## getButton()

uint8_t IRHaierACYRW02::getButton | ( | void |  | ) | const

Get the Button/Command setting of the A/C.

Returns
  The value of the button/command that was pressed.

## getFan()

uint8_t IRHaierACYRW02::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## getHealth()

bool IRHaierACYRW02::getHealth | ( | void |  | ) | const

Get the Health (filter) setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## getMode()

uint8_t IRHaierACYRW02::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## getPower()

bool IRHaierACYRW02::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## getRaw()

uint8_t * IRHaierACYRW02::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## getSleep()

bool IRHaierACYRW02::getSleep | ( | void |  | ) | const

Get the Sleep setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## getSwing()

uint8_t IRHaierACYRW02::getSwing | ( | void |  | ) | const

Get the Vertical Swing position setting of the A/C.

Returns
  The native position/mode.

## getTemp()

uint8_t IRHaierACYRW02::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## getTurbo()

uint8_t IRHaierACYRW02::getTurbo | ( | void |  | ) | const

Get the Turbo setting of the A/C.

Returns
  The current turbo speed setting.

## off()

void IRHaierACYRW02::off | ( | void |  | ) |

Change the power setting to Off.

## on()

void IRHaierACYRW02::on | ( | void |  | ) |

Change the power setting to On.

## send()

void IRHaierACYRW02::send | ( | const uint16_t | repeat = `kHaierAcYrw02DefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## setButton()

void IRHaierACYRW02::setButton | ( | const uint8_t | button | ) |

Set the Button/Command setting of the A/C.

Parameters

  [in] | button | The value of the button/command that was pressed.

## setFan()

void IRHaierACYRW02::setFan | ( | const uint8_t | speed | ) |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.

## setHealth()

void IRHaierACYRW02::setHealth | ( | const bool | on | ) |

Set the Health (filter) setting of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## setMode()

void IRHaierACYRW02::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## setPower()

void IRHaierACYRW02::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## setRaw()

void IRHaierACYRW02::setRaw | ( | const uint8_t | new_code[] | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

## setSleep()

void IRHaierACYRW02::setSleep | ( | const bool | on | ) |

Set the Sleep setting of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## setSwing()

void IRHaierACYRW02::setSwing | ( | const uint8_t | pos | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | pos | The position/mode to set the vanes to.

## setTemp()

void IRHaierACYRW02::setTemp | ( | const uint8_t | celsius | ) |

Set the temperature.

Parameters

  [in] | celsius | The temperature in degrees celsius.

## setTurbo()

void IRHaierACYRW02::setTurbo | ( | const uint8_t | speed | ) |

Set the Turbo setting of the A/C.

Parameters

  [in] | speed | The desired turbo speed setting.

Note
  Valid speeds are kHaierAcYrw02TurboOff, kHaierAcYrw02TurboLow, & kHaierAcYrw02TurboHigh.

## stateReset()

void IRHaierACYRW02::stateReset | ( | void |  | ) |

private

Reset the internal state to a fixed known good state.

## toCommon()

stdAc::state_t IRHaierACYRW02::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## toCommonFanSpeed()

stdAc::fanspeed_t IRHaierACYRW02::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## toCommonMode()

stdAc::opmode_t IRHaierACYRW02::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## toCommonSwingV()

stdAc::swingv_t IRHaierACYRW02::toCommonSwingV | ( | const uint8_t | pos | ) |

static

Convert a stdAc::swingv_t enum into it's native setting.

Parameters

  [in] | pos | The enum to be converted.

Returns
  The native equivalent of the enum.

## toString()

String IRHaierACYRW02::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## validChecksum()

bool IRHaierACYRW02::validChecksum | ( | uint8_t | state[],
|  | const uint16_t | length = `kHaierACYRW02StateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## _

HaierYRW02Protocol IRHaierACYRW02::_

private

## _irsend

IRsend IRHaierACYRW02::_irsend

private

Instance of the IR send class.

The documentation for this class was generated from the following files:

- src/ir_Haier.h
- src/ir_Haier.cpp